## Service-side Channel Dispatch Operation interface

Service-side Channel Dispatch Operation interface — GInterface for Telepathy ChannelDispatchOperation object

## Functions

void | tp_svc_channel_dispatch_operation_return_from_claim ()
void | (*tp_svc_channel_dispatch_operation_claim_impl) ()
void | tp_svc_channel_dispatch_operation_implement_claim ()
void | tp_svc_channel_dispatch_operation_return_from_handle_with ()
void | (*tp_svc_channel_dispatch_operation_handle_with_impl) ()
void | tp_svc_channel_dispatch_operation_implement_handle_with ()
void | (*tp_svc_channel_dispatch_operation_handle_with_time_impl) ()
void | tp_svc_channel_dispatch_operation_implement_handle_with_time ()
void | tp_svc_channel_dispatch_operation_return_from_handle_with_time ()
void | tp_svc_channel_dispatch_operation_emit_channel_lost ()
void | tp_svc_channel_dispatch_operation_emit_finished ()

## Signals

void | channel-lost | Has Details
void | finished | Has Details

## Types and Values

| TpSvcChannelDispatchOperation
| TpSvcChannelDispatchOperationClass

## Object Hierarchy

        GInterface
        ╰── TpSvcChannelDispatchOperation

## Includes

    #include <telepathy-glib/telepathy-glib-dbus.h>

## Description

This interface (auto-generated from the Telepathy spec) makes it easier to export an object implementing the Telepathy ChannelDispatchOperation interface, with the correct method and signal signatures, and emit signals from that object in a type-safe way.

You don't need these interfaces unless you're implementing a Telepathy ChannelDispatcher, such as Mission Control.

## Functions

### tp_svc_channel_dispatch_operation_return_from_claim ()

    void
    tp_svc_channel_dispatch_operation_return_from_claim
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_channel_dispatch_operation_claim_impl ()

    void
    (*tp_svc_channel_dispatch_operation_claim_impl)
                                   (TpSvcChannelDispatchOperation *self,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method Claim on interface org.freedesktop.Telepathy.ChannelDispatchOperation.

#### Parameters

self | The object implementing this interface |
context | Used to return values or throw an error |

### tp_svc_channel_dispatch_operation_implement_claim ()

    void
    tp_svc_channel_dispatch_operation_implement_claim
                                   (TpSvcChannelDispatchOperationClass *klass,
                                    tp_svc_channel_dispatch_operation_claim_impl impl);

Register an implementation for the Claim method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the Claim D-Bus method |

### tp_svc_channel_dispatch_operation_return_from_handle_with ()

    void
    tp_svc_channel_dispatch_operation_return_from_handle_with
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_channel_dispatch_operation_handle_with_impl ()

    void
    (*tp_svc_channel_dispatch_operation_handle_with_impl)
                                   (TpSvcChannelDispatchOperation *self,
                                    const gchar *in_Handler,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method HandleWith on interface org.freedesktop.Telepathy.ChannelDispatchOperation.

#### Parameters

self | The object implementing this interface |
in_Handler | const gchar * (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_channel_dispatch_operation_implement_handle_with ()

    void
    tp_svc_channel_dispatch_operation_implement_handle_with
                                   (TpSvcChannelDispatchOperationClass *klass,
                                    tp_svc_channel_dispatch_operation_handle_with_impl impl);

Register an implementation for the HandleWith method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the HandleWith D-Bus method |

### tp_svc_channel_dispatch_operation_handle_with_time_impl ()

    void
    (*tp_svc_channel_dispatch_operation_handle_with_time_impl)
                                   (TpSvcChannelDispatchOperation *self,
                                    const gchar *in_Handler,
                                    gint64 in_UserActionTime,
                                    DBusGMethodInvocation *context);

The signature of an implementation of the D-Bus method HandleWithTime on interface org.freedesktop.Telepathy.ChannelDispatchOperation.

#### Parameters

self | The object implementing this interface |
in_Handler | const gchar * (FIXME, generate documentation) |
in_UserActionTime | gint64 (FIXME, generate documentation) |
context | Used to return values or throw an error |

### tp_svc_channel_dispatch_operation_implement_handle_with_time ()

    void
    tp_svc_channel_dispatch_operation_implement_handle_with_time
                                   (TpSvcChannelDispatchOperationClass *klass,
                                    tp_svc_channel_dispatch_operation_handle_with_time_impl impl);

Register an implementation for the HandleWithTime method in the vtable of an implementation of this interface. To be called from the interface init function.

#### Parameters

klass | A class whose instances implement this interface |
impl | A callback used to implement the HandleWithTime D-Bus method |

### tp_svc_channel_dispatch_operation_return_from_handle_with_time ()

    void
    tp_svc_channel_dispatch_operation_return_from_handle_with_time
                                   (DBusGMethodInvocation *context);

Return successfully by calling `dbus_g_method_return()`. This inline function exists only to provide type-safety.

#### Parameters

context | The D-Bus method invocation context |

### tp_svc_channel_dispatch_operation_emit_channel_lost ()

    void
    tp_svc_channel_dispatch_operation_emit_channel_lost
                                   (gpointer instance,
                                    const gchar *arg_Channel,
                                    const gchar *arg_Error,
                                    const gchar *arg_Message);

Type-safe wrapper around g_signal_emit to emit the ChannelLost signal on interface org.freedesktop.Telepathy.ChannelDispatchOperation.

#### Parameters

instance | The object implementing this interface |
arg_Channel | const gchar * (FIXME, generate documentation) |
arg_Error | const gchar * (FIXME, generate documentation) |
arg_Message | const gchar * (FIXME, generate documentation) |

### tp_svc_channel_dispatch_operation_emit_finished ()

    void
    tp_svc_channel_dispatch_operation_emit_finished
                                   (gpointer instance);

Type-safe wrapper around g_signal_emit to emit the Finished signal on interface org.freedesktop.Telepathy.ChannelDispatchOperation.

#### Parameters

instance | The object implementing this interface |

## Types and Values

### TpSvcChannelDispatchOperation

    typedef struct _TpSvcChannelDispatchOperation TpSvcChannelDispatchOperation;

Dummy typedef representing any implementation of this interface.

### TpSvcChannelDispatchOperationClass

    typedef struct _TpSvcChannelDispatchOperationClass TpSvcChannelDispatchOperationClass;

The class of TpSvcChannelDispatchOperation.

In a full implementation of this interface (i.e. all methods implemented), the interface initialization function used in `G_IMPLEMENT_INTERFACE()` would typically look like this:

    static void
    implement_channel_dispatch_operation (gpointer klass,
        gpointer unused G_GNUC_UNUSED)
    {
    #define IMPLEMENT(x) tp_svc_channel_dispatch_operation_implement_##x (\
      klass, my_object_##x)
      IMPLEMENT (handle_with);
      IMPLEMENT (claim);
      IMPLEMENT (handle_with_time);
    #undef IMPLEMENT
    }

## Signal Details

### The `“channel-lost”` signal

    void
    user_function (TpSvcChannelDispatchOperation *self,
                   DBusGObjectPath               *arg_Channel,
                   gchar                         *arg_Error,
                   gchar                         *arg_Message,
                   gpointer                       user_data)

The ChannelLost D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
arg_Channel | const gchar * (FIXME, generate documentation) |
arg_Error | const gchar * (FIXME, generate documentation) |
arg_Message | const gchar * (FIXME, generate documentation) |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“finished”` signal

    void
    user_function (TpSvcChannelDispatchOperation *self,
                   gpointer                       user_data)

The Finished D-Bus signal is emitted whenever this GObject signal is.

#### Parameters

self | an object |
user_data | user data set when the signal handler was connected. |

Flags: Has Details